
<?= $element->renderSubmenu('/3-lekce-cykly'); ?>

<h1 class="mainTitle"><?= $template->title; ?></h1>

<p><b>Cyklus</b> je část kódu, která opakovaně provádí sled příkazů. Počet opakování cyklu určujeme <b>podmínkou</b>.</p>

<h2 class="mainTitle" id="while">while - Cyklus s podmínkou na začátku</h2>

<p>Cyklus <b>while</b> se opakuje dokud je podmínka splněna. Klíčové slovíčko je zde <b class="text-pink-dark">while</b> a příkazy prováděné uvnitř cyklu se uzavírají do chlupatých závorek <b>{</b> a <b>}</b>.</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">echo</span> <span class="php__str">"Začínáme za: "</span>;

    <span class="php__var">$odpocet</span> = <span class="php__num">5</span>;
    <span class="php__syntax">while</span> (<span class="php__var">$odpocet</span> > <span class="php__num">0</span>) {
        <span class="php__syntax">echo</span> <span class="php__var">$odpocet</span>;
        <span class="php__var">$odpocet</span> = <span class="php__var">$odpocet</span> - <span class="php__num">1</span>;
    }
?&gt;
</pre>

<p>
	Pojďme se na to podívat. Na začátku si <b>$odpocet</b> nastavíme na hodnotu <b>5</b>.
	V cyklu <b>while</b> se poté ptáme, zda je <b>$odpocet</b> větší než 0. To je na začátku pravda, takže se vypíše číslo 5.
	Následně <b>$odpocet snížíme</b> o hodnotu 1. Následuje opět <b>vyhodnocení podmínky</b>, zda je $odpocet větší než 0.
	Takhle to jde do doby než, je <b>$odpocet</b> roven 0. V tuto chvíli podmínka není splněna a <b>cyklus končí</b>.
</p>

<p>Pokud bychom v tomto případě <b>nesnižovali</b> hodnotu proměnné $odpocet, nastal by <b>nekonečný cyklus</b>. A to nechceme, protože nekonečný cyklus v lepším případě skončí <b>chybou</b>. V horším případě zničíme procesor.</p>

<div class="tip">
	<div class="tip__title"><b>Tip:</b></div>
	<p class="tip__text">
		Výraz "<b>$odpocet = $odpocet - 1</b>" můžeme zjednodušit na "<b>$odpocet--</b>".<br>
		Stejně to funguje i při výrazu "<b>$odpocet = $odpocet + 1</b>", to můžeme napsat jako "<b>$odpocet++</b>".
	</p>
</div>

<h2 class="mainTitle" id="do-while">do while - Cyklus s podmínkou na konci</h2>

<p>
	Cyklus s podmínkou na konci je velmi podobný cyklu <b>while</b>. Rozdíl je v zápisu a tom, že podmínku vyhodnocujeme až na konci.<br>
	To znamená, že cyklus <b class="text-pink-dark">do-while</b> se provede minimálně jednou.
</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">echo</span> <span class="php__str">"Začínáme za: "</span>;

    <span class="php__var">$odpocet</span> = <span class="php__num">5</span>;
    <span class="php__syntax">do</span> {
        <span class="php__syntax">echo</span> <span class="php__var">$odpocet</span>;
        <span class="php__var">$odpocet</span>--;
    } <span class="php__syntax">while</span> (<span class="php__var">$odpocet</span> > <span class="php__num">0</span>);
?&gt;
</pre>

<h2 class="mainTitle" id="for">for - Cyklus s konkrétním počtem opakování</h2>
<p>Pokud chceme provést stejnou operaci přesně <b>x</b> (třeba naplnit pole náhodnými hodnotami), využijeme cyklus <b class="text-pink-dark">for</b>.</p>

<pre class="php">
&lt;?php
    <span class="php__var">$pole</span> = <span class="php__syntax">array</span>();

    <span class="php__syntax">for</span> (<span class="php__var">$i</span> = <span class="php__num">1</span>; <span class="php__var">$i</span> &lt;= <span class="php__num">10</span>; <span class="php__var">$i</span>++) {
        <span class="php__var">$pole</span>[] = <span class="php__syntax">rand</span>(<span class="php__num">1</span>, <span class="php__num">10</span>);
    }
?&gt;
</pre>

<p>Rozeberme si to. Nejdříve napíšeme klíčové slovíčko <b>for</b>. Poté následuje kulatá závorka.</p>
<ul>
	<li><b><span class="php__var">$i</span> = <span class="php__num">1</span></b> - incializace tzv. <b>iterátoru</b> (název proměnné je libovolný)</li>
	<li><b><span class="php__var">$i</span> >= <span class="php__num">10</span></b> - podmínka která se vyhodnocuje <b>před každým dalším průchodem</b> cyklu. Pokud je splněna, provede se další průchod.</li>
	<li><b><span class="php__var">$i</span>++</b> - zvýšení hodnoty <b>po každém průchodu</b> cyklu</li>
</ul>

<div class="tip">
	<div class="tip__title"><b>Tip:</b></div>
	<p class="tip__text">
		Pro náhodné generování celých čísel můžeme použít PHP funkci <a href="https://www.php.net/manual/en/function.rand.php" target="_blank" class="font-bold text-pink-dark">rand()</a>.
		Pokud ji předáme 2 argumenty (2 čísla), generované číslo bude pouze z tohoto intervalu (včetně).
	</p>
</div>

<h2 class="mainTitle" id="foreach">foreach - Cyklus pro průchod polem</h2>
<p>Tento cyklus se používá, když potřebujeme pracovat s každou hodnotou v poli, ale neznáme jeho délku. Nebo ji znát nepotřebujeme.</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">foreach</span> (<span class="php__var">$skrin</span> <span class="php__syntax">as</span> <span class="php__var">$polozka</span>) {
        <span class="php__syntax">echo</span> <span class="php__var">$polozka</span>;
    }
?&gt;
</pre>

<p>
	Když se na kód podíváme, tak proměnná <b>$skrin</b> je pole. Poté následuje klíčové slovíčko <b>as</b>.
	Nyní napíšeme <b>název proměnné</b> (názve můžeme zvolit podle sebe). V této proměnné poté bude vždy <b>aktuální prvek</b> pole.<br>
	Když se provedou všechny příkazy v těle cyklu (mezi <b>{</b> a <b>}</b>), PHP se podívá do našeho pole a pokud existuje další hodnota v poli, přiřadí ji do naší proměnné.
</p>

<p>Kdybychom chtěli stejný kód napsat pomocí cyklu <b>for</b>, napsali bychom to <span class="link" data-open-code="for-simple">takto</span>.</p>

<div class="hidden" data-open-code-id="for-simple">
	<pre class="php">
&lt;?php
    <span class="php__var">$pocetPrvkuVPoli</span> = <span class="php__syntax">count</span>(<span class="php__var">$skrin</span>);

    <span class="php__syntax">for</span> (<span class="php__var">$i</span> = <span class="php__num">0</span>; <span class="php__var">$i</span> &lt; <span class="php__var">$pocetPrvkuVPoli</span>; <span class="php__var">$i</span>++) {
        <span class="php__syntax">echo</span> <span class="php__var">$polozka</span>;
    }
?&gt;
	</pre>

	<div class="tip">
		<div class="tip__title"><b>Tip:</b></div>
		<p class="tip__text">
			Počet prvků v poli zjistíme pomocí PHP funkce <a href="https://www.php.net/manual/en/function.count.php" target="_blank" class="font-bold text-pink-dark">count()</a>.
		</p>
	</div>

</div>

<h3>Hodnota i s klíčem</h3>

<p>Také je možné vypsat pro každou hodnotu jeho klíč. To zapíšeme takto:</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">foreach</span> (<span class="php__var">$skrin</span> <span class="php__syntax">as</span> <span class="php__var">$regal</span> => <span class="php__var">$polozka</span>) {
        <span class="php__syntax">echo</span> <span class="php__str">"Na <span class="php__var">{$regal}</span> mám <span class="php__var">{$polozka}</span>"</span>;
    }
?&gt;
</pre>

<h2 class="mainTitle" id="konstrukce">Konstrukce v cyklech</h2>

<h3>break - ukončení cyklu</h3>

<p>Pokud v bloku kódu cyklu použijeme klíčové slovíčko <b class="text-pink-dark">break</b>, ihned ukončíme cyklus.</p>

<pre class="php">
&lt;?php
    <span class="php__var">$pole</span> = <span class="php__syntax">array</span>();

    <span class="php__syntax">for</span> (<span class="php__var">$i</span> = <span class="php__num">1</span>; <span class="php__var">$i</span> &lt;= <span class="php__num">10</span>; <span class="php__var">$i</span>++) {
        <span class="php__syntax">if</span> (<span class="php__var">$i</span> == <span class="php__num">5</span>) {
            <span class="php__syntax">break</span>;
        }
        <span class="php__var">$pole</span>[] = <span class="php__syntax">rand</span>(<span class="php__num">1</span>, <span class="php__num">10</span>);
    }
?&gt;
</pre>

<h3>continue - pokračování dalším prvkem</h3>

<p>Pokud v bloku kódu cyklu použijeme klíčové slovíčko <b class="text-pink-dark">continue</b>, ukončíme aktuální průchod cyklu. Ten se následně posune na další prvek.</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">foreach</span> (<span class="php__var">$skrin</span> <span class="php__syntax">as</span> <span class="php__var">$polozka</span>) {
        <span class="php__syntax">if</span> (<span class="php__var">$polozka</span> == <span class="php__str">""</span>) {
            <span class="php__syntax">continue</span>;
        }
        <span class="php__syntax">echo</span> <span class="php__var">$polozka</span>;
    }
?&gt;
</pre>